package nl.bartpelle.veteres.content.items

import co.paralleluniverse.fibers.Suspendable
import nl.bartpelle.skript.Script
import nl.bartpelle.skript.ScriptMain
import nl.bartpelle.veteres.content.animate
import nl.bartpelle.veteres.model.AttributeKey
import nl.bartpelle.veteres.net.message.game.command.InterfaceText
import nl.bartpelle.veteres.net.message.game.command.InterfaceVisibility
import nl.bartpelle.veteres.net.message.game.command.InvokeScript
import nl.bartpelle.veteres.script.ScriptRepository

/**
 * Created by Situations on 4/18/2016.
 * Revamped by Jak on 31/12/2017
 */

class QaBookPageV2(val pageId: Int, val left: Int, val right: Int, val title: String, val lines: List<String>, val skips: Map<Int, Int>? = null)

class Books(val id: Int, val pages: List<QaBookPageV2>)

object QABook {

	val QA_RENDER = arrayListOf(
			Books(1, arrayListOf(
					QaBookPageV2(1, -1, 2, "OS-Scape Information Book", arrayListOf(
							"Chapters", "", "",
							"<c><col=000080>Getting Started", "<c><col=000080>Making Money", "<c><col=000080>Ways To Travel",
							"<c><col=000080>Account Security", "", "",
							"", "", "",
							"", "", "",
							"<col=000080>Getting Started", "<col=000000>Playing OS-Scape PVP is", "<col=000000>extremely easy to do. You",
							"<col=000000>can begin playing by", "<col=000000>opening your quest tab to", "<col=000000>access presets which will give",
							"<col=000000>you basic gear and will also", "set your stats.", "",
							"From there, you can jump into", "the wilderness and slay enemies", "for blood money which can be",
							"used to purchase better weapons", "and armour.", ""
					), hashMapOf(107 to 1, 109 to 2, 111 to 3, 113 to 4)),
					QaBookPageV2(2, 3, 4, "", arrayListOf(
					"<col=000080>Making Money", "In the world of OS-Scape",
					"PvP, the currency is known", "as Blood money. Blood-red", "coins collected from the",
					"corpse of those slaughtered.", "", "Although the most straight",
					"forward way to earn Blood", "money is killing people in", "the Wilderness, you also",
					"have the option to fight", "boss monsters for their", "drops and Blood money",
					"", "", "rewards. When killing people", // 17
					"in the Wilderness, you could", "target those with a bounty", "on their heads and earn a",
					"potentially huge shutdown", "reward. But we aware, those", "with bounties have slayed many",
					"innocent players inside the", "wilderness.", "",
					"", "", "", ""
					)),
					QaBookPageV2(3, 5, 6, "", arrayListOf(
					"<col=000080>Ways To Travel", "Travelling on OS-Scape is", "extremely easy. We offer",
					"game commands to help", "you jump straight into", "action. Here are the",
					"available commands:", "", "::easts, ::44s, ::wests,",
					"::magebank, ::52s, ::gdz,", "::35z, ::grave, and ::edge.", "",
					"We also have a Wizard", "that will teleport you to", "",
					"", "many different locations.", "He is located on the west",
					"side of Edgeville bank.", "", "Other then that, we offer",
					"amulets such as the Amulet", "of Glory, teleportation", "tablets, and teleportation",
					"scrolls.", "", "",
					"", "", ""
					)),
					QaBookPageV2(4, 7, -1, "", arrayListOf(
					"<col=000080>Account Security", "", "Keeping your account safe",
					"is extremely important to us,", "and because of that, we have", "implemented the powerful 2FA",
					"(Two-Factor Authentication).", "into our game.", "",
					"This makes it so you'll be", "prompted for a 6-digit code", "automatically, and randomly",
					"generated by your mobile", "device or computer application.", "You can enable and set this",
					"", "", "by typing:",
					"", "::2fa", "",
					"We also give players", "the ability to change", "their password. You can",
					"do this by typing a ", "simple command:", "",
					"::changepassword newpasshere", "", ""
					))
			)),
			Books(2, arrayListOf(
					QaBookPageV2(1, -1, 2, "The Blood Chest Vol.1", arrayListOf(
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", ""
					), hashMapOf(107 to 1, 109 to 2, 111 to 3, 113 to 4, 115 to 5)),
					QaBookPageV2(2, 3, 4, "", arrayListOf(
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", ""
					)),
					QaBookPageV2(3, 5, 6, "", arrayListOf(
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", ""
					)),
					QaBookPageV2(4, 7, 8, "", arrayListOf(
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", ""
					)),
					QaBookPageV2(5, 9, -1, "", arrayListOf(
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", "",
							"", "", ""
					))
			))

	)

	fun showTurnButtons(it: Script, left: Boolean, right: Boolean) {
		it.player().write(InterfaceVisibility(27, 97, left))
		it.player().write(InterfaceVisibility(27, 95, right))
	}
	
	val QA_BOOK = 5520

	val BLOOD_CHEST_BOOK = 9717
	
	@JvmStatic @ScriptMain fun register(r: ScriptRepository) {
		r.onItemOption1(QA_BOOK) @Suspendable {
			open(it)
		}
		r.onItemOption1(BLOOD_CHEST_BOOK) @Suspendable {
			it.player().putattrib(AttributeKey.OPEN_BOOK_ID, 2)
			openpage(it, 1)
		}

		r.onButton(27, 162) {
			//Close book
			it.player().interfaces().closeById(27)
			it.player().animate(-1)
		}
		r.onButton(27, 160) {
			// Back to First page button in the top right next to X
			it.player().interfaces().closeById(27)
			openpage(it, 1)
		}
		r.onButton(27, 94) { openpage(it, it.player().attribOr<Int>(AttributeKey.QA_BOOK_PAGE, 0) - 1) } //Turning the page left
		r.onButton(27, 96) { openpage(it, it.player().attribOr<Int>(AttributeKey.QA_BOOK_PAGE, 0) + 1) } //Turning the page right


		for (i in 101 .. 162) {
			if (i % 2 == 0) // skip even numbers
				continue
			r.onButton(27, i) {
				val p = it.player()
				val pages: Books = QA_RENDER.find { b -> b.id == p.attribOr<Int>(AttributeKey.OPEN_BOOK_ID, -1) }!!
				val r: QaBookPageV2 = pages.pages.find { q -> q.pageId == p.attribOr<Int>(AttributeKey.QA_BOOK_PAGE, -1) }!!
				openpage(it, r.skips!!.getOrDefault(i, 1))
			}
		}
	}
	
	@Suspendable fun openpage(it: Script, pageId: Int) {
		val p = it.player()
		if (pageId < 1) {
			p.message("There is no page $pageId.")
			return
		}
		/*if (p.attribOr<Int>(AttributeKey.QA_BOOK_PAGE, -1) == pageId) {// already on it
			p.message("You're already on page $pageId.")
			return
		}*/
		val pages: Books = QA_RENDER.find { b -> b.id == p.attribOr<Int>(AttributeKey.OPEN_BOOK_ID, -1) }!!
		
		it.player().stopActions(false)
		p.putattrib(AttributeKey.QA_BOOK_PAGE, pageId)
		p.interfaces().sendMain(27)
		p.invokeScript(InvokeScript.SETVARCS, -1, -1)
		it.animate(1350)

		val r: QaBookPageV2 = pages.pages.find { q -> q.pageId == pageId }!!
		p.write(InterfaceText(27, 98, "${if (r.left == -1) "" else r.left}"))
		p.write(InterfaceText(27, 99, "${if (r.right == -1) "" else r.right}"))
		p.write(InterfaceVisibility(27, 97, r.right == -1)) // right btn, true=hide
		p.write(InterfaceVisibility(27, 95, r.left == -1)) // 95 = left button, true=hide

		p.write(InterfaceText(27, 3, r.title))
		p.write(InterfaceVisibility(27, 4, true)) // its a big cross wtf
		p.write(InterfaceVisibility(27, 100, true)) // no idea what this is cant get it to show up

		var startTextChild = 33
		var startVis1 = 6
		var startVis2 = 102
		var clickableComponent = 100 // starts at 100, but the button is actually an odd number lol

		r.lines.forEach { l ->
			p.write(InterfaceText(27, startTextChild++, l))
			p.write(InterfaceVisibility(27, startVis1, true)) // TODO work out which is which one clicklink one plaintext?
			p.write(InterfaceVisibility(27, startVis2, true))
			// custom <c> markup for click
			p.write(InterfaceVisibility(27, clickableComponent, !l.startsWith("<c>")))
			startVis1 += 2
			startVis2 += 2
			clickableComponent += 2
		}
	}

	fun open(it: Script) {
		it.player().putattrib(AttributeKey.OPEN_BOOK_ID, 1)
		openpage(it, 1)
	}
}